version: "2.0"

volumes:
  lsp_pgdata:
    driver: local

services:
  #
  # docker exec -it pg psql -u postgres
  #

  postgres:
    container_name: lsp_pg
    hostname: postgres
    image: postgres:12
    restart: "no"
    environment:
      - POSTGRES_USER=postgres
      - POSTGRES_PASSWORD=pa55w0rd
      - POSTGRES_DB=postgres
    volumes:
      - lsp_pgdata:/var/lib/postgresql/data
      - ./init.sql:/docker-entrypoint-initdb.d/init.sql
    ports:
      - 5432:5432
    networks:
      - holo

  # See https://github.com/jinnerbichler/keycloak-nginx
  lspkeycloak:
    container_name: lspkeycloak
    # image: quay.io/keycloak/keycloak:9.0.2
    image: quay.io/keycloak/keycloak:11.0.2
    hostname: lspkeycloak
    environment:
      - KEYCLOAK_USER=admin
      - KEYCLOAK_PASSWORD=admin
      - PROXY_ADDRESS_FORWARDING=true
      - DB_DATABASE=keycloak
      - DB_VENDOR=postgres
      - DB_USER=keycloak
      - DB_PASSWORD=keycloak
      - DB_ADDR=postgres
      - KEYCLOAK_IMPORT=/tmp/clusteradmin-realm.json
    volumes:
      - ./clusteradmin-realm.json:/tmp/clusteradmin-realm.json
    networks:
      - holo
    expose:
      - 8080
    ports:
      - 8084:8080

  mtcpmgt:
    container_name: mtcpmgt
    hostname: mtcpmgt
    image: docker.semweb.co/mtcpmgt:latest
    networks:
      - holo
    environment:
      - PROVISIONED_DB_HOST=postgres
      - DATASOURCE_URL=jdbc:postgresql://postgres:5432/mtcp_registry
      - DATASOURCE_USERNAME=mtcp
      - DATASOURCE_PASSWORD=mtcp
      - DATASOURCES_MTCP_URL=jdbc:postgresql://postgres:5432/mtcp_registry
      - DATASOURCES_MTCP_USERNAME=mtcp
      - DATASOURCES_MTCP_PASSWORD=mtcp
      - KEYCLOAK_URL=http://lspkeycloak:8080
    ports:
      - 8082:8080
    expose:
      - 8080

  holocoreservice:
    container_name: holocoreservice
    hostname: holocoreservice
    image: docker.semweb.co/holo_core_service:latest
    environment:
      - KEYCLOAK_URL=http://lspkeycloak:8080
      - MTCPMGT_URL=http://mtcpmgt:8080
    networks:
      - holo


  # If you just want to run the lsp service to develop a front end, use this stanza
  # If you want to build-run-test lspcore, leave this commented out and run the service using
  # ./scripts/run_lsp_service.sh to execute the compiled executable .war on the holo network
  #

  # lspcore:
  #   container_name: lspcore
  #   hostname: lspcore
  #   image: docker.semweb.co/lspcore:latest
  #   environment:
  #     - KEYCLOAK_URL=http://lspkeycloak:8080
  #     - MTCPMGT_URL=http://mtcpmgt:8080
  #   networks:
  #     - holo



  gateway:
    image: nginx
    networks:
      - holo
    volumes:
      - "./nginx-conf:/etc/nginx/conf.d"
    ports:
      - 8080:8080

networks:
  holo:

